import styled from "@emotion/styled";
import { background, breakpoints, foreground, text } from "@recourse/commons";
import type { NextPage } from "next";
import Head from "next/head";
import { useCallback, useEffect, useRef, useState } from "react";
import { Header, headerHeight } from "./header";
import CardIcon from "./icons/card.svg";
import CardIcon2 from "./icons/card2.svg";
import CardMobile from "./icons/cardMobile.svg";
import CardMobile2 from "./icons/cardMobile2.svg";
import footerBackground from "./icons/footer.svg?url";
import FooterLogo from "./icons/icon.svg";
import NameIcon from "./icons/name.svg";
import { screens } from "./screen";

export const Page: NextPage = () => {
	const cardContainerRef = useRef<HTMLDivElement>(null);
	const cardRefs = useRef([
		useRef<HTMLDivElement>(null),
		useRef<HTMLDivElement>(null),
	]).current;
	const [visible, setVisible] = useState(0);
	const scrolled = false;
	const next = useCallback(() => {
		setVisible((visible) => {
			cardRefs[visible].current?.scrollIntoView({
				behavior: `smooth`,
				block: `nearest`,
				inline: `nearest`,
			});
			return (visible + 1) % cardRefs.length;
		});
	}, [cardRefs]);

	useEffect(() => {
		const interval = setInterval(next, 5000);
		return () => {
			clearInterval(interval);
		};
	}, [next]);

	const [honzaCounter, setHonzaCounter] = useState(0);
	const [honza, setHonza] = useState(`Jan Gabriel Feřstek`);
	useEffect(() => {
		honzaCounter > 2 && setHonza(`Hogafe`);
	}, [honzaCounter]);
	return (
		<>
			<Head>
				<title>Recourse</title>
				<meta
					name="description"
					content="Generated by create next app"
				/>
				<link rel="icon" href="/favicon.ico" />
			</Head>
			<Wrapper scrolled={scrolled}>
				<Header />
				<Content>
					<Left>
						<LeftLogo />
						<Motto>Learn and grow with ease</Motto>
					</Left>
					<Right>
						<RightContentCardWrapper
							ref={cardContainerRef}
							onClick={() => {
								setVisible((visible + 1) % cardRefs.length);
							}}
						>
							<AnimationState ref={cardRefs[0]}>
								<a
									href={`/courses/b34fddb9-5d98-46b6-9bc7-6baeba51309b/detail/9b2df6f5-31ba-4e5d-9dff-4fe93bb0d61b`}
								>
									<CardSmall />
									<CardBig />
								</a>
							</AnimationState>

							<AnimationState ref={cardRefs[1]}>
								<a
									href={`/courses/6cbe9315-ac7f-424e-902e-15b61a5d2004/detail/bada9ae3-d475-4dd6-8206-202ac6c18254`}
								>
									<CardSmall2 />
									<CardBig2 />
								</a>
							</AnimationState>
						</RightContentCardWrapper>
					</Right>
				</Content>
			</Wrapper>
			<Filler />
			<Footer>
				<FooterLeft>
					<FooterLeftTitle>Our team:</FooterLeftTitle>
					<div>
						<OurNames
							onClick={() => setHonzaCounter(honzaCounter + 1)}
						>
							{honza}
						</OurNames>
						<OurNames>Dominik Frána</OurNames>
						<OurNames>František Hanzlík</OurNames>
						<OurNames>Michal Nejezchleba</OurNames>
					</div>
				</FooterLeft>
				<FooterRight>
					<FooterLogoTextWrapper>
						<FooterText>School project 2022/2023</FooterText>
						<LogoWrapper>
							<FooterRightLogo />
						</LogoWrapper>
					</FooterLogoTextWrapper>
				</FooterRight>
			</Footer>
		</>
	);
};
const Wrapper = styled(screens.Custom)<{ scrolled: boolean }>`
	position: fixed;
	inset: 0;
	box-shadow: inset 0 1rem 1rem -1rem hsla(0, 0%, 0%, 0.1); //move to commons
	${background(`normal`)}
`;

const Content = styled.div`
	display: flex;
	flex-direction: column;
	justify-content: center;
	height: calc(100vh - ${headerHeight});
	@media (min-width: ${breakpoints.xl}) {
		flex-direction: row;
	}
	z-index: -1;
`;
const Left = styled.section`
	display: flex;
	flex-direction: column;
	justify-content: center;
	align-items: center;
	flex-grow: 2;
`;
const Right = styled.section`
	display: flex;
	flex-grow: 1;
	@media (min-width: ${breakpoints.sm}) {
		padding: 8rem 1rem 4rem 1rem;
	}
	padding: 1rem;
	align-items: center;
	justify-content: center;
`;

const LeftLogo = styled(NameIcon)`
	${foreground(`primary`)};
	--color-initial-letter: ${(p) => p.theme.colours.foreground.primary};
	--color-rest-of-the-name: ${(p) => p.theme.colours.foreground.normal};
	transform: scale(150%);
`;
const FooterRightLogo = styled(FooterLogo)`
	${foreground(`primary`)};
	--color-initial-letter: ${(p) => p.theme.colours.foreground.primary};
	--color-rest-of-the-name: ${(p) => p.theme.colours.foreground.normal};
	transform: scale(250%);
`;
const Motto = styled.p`
	@media (min-width: ${breakpoints.sm}) {
		${text({ family: `quicksand`, size: 2 })}
	}
	padding-top: 1rem;
	${text({ family: `quicksand`, size: 1 })};
`;
const cardWidthBig = `44rem`;
const cardWidthSmall = `23rem`;
const RightContentCardWrapper = styled.div`
	@media (min-width: ${breakpoints.md}) {
		width: ${cardWidthBig};
	}
	width: ${cardWidthSmall};
	height: 30rem;
	border-radius: 2rem;
	display: flex;
	overflow: hidden;
`;
const Filler = styled.div`
	height: 100vh;
	width: 100vw;
`;

const AnimationState = styled.div`
	@media (min-width: ${breakpoints.md}) {
		flex-basis: ${cardWidthBig};
	}
	flex-shrink: 0;
	flex-basis: ${cardWidthSmall};
`;
const Footer = styled.footer`
	@media (min-width: ${breakpoints.md}) {
		height: 35rem;
		gap: 0;
	}
	@media (min-width: ${breakpoints.xl}) {
		flex-direction: row;
		height: 23rem;
		gap: 0;
	}
	display: flex;
	flex-direction: column;
	width: 100%;
	height: 43rem;
	gap: 1rem;
	background-image: url("${footerBackground}");
	background-size: cover;
	background-repeat: no-repeat;
	justify-content: space-between;
	position: relative;
	z-index: 1;
`;
const FooterLeft = styled.div`
	padding: 9rem 0 0 1rem;
	gap: 2rem;

	display: flex;
	flex-direction: column;
	@media (min-width: ${breakpoints.md}) {
		padding: 7rem 0 0 4rem;
		flex-direction: column;
	}
	@media (min-width: ${breakpoints.xl}) {
		padding: 7rem 0 0 4rem;
		flex-direction: row;
		gap: 5rem;
	}
`;
const FooterText = styled.p`
	${text({ family: `quicksand`, size: 2, colour: `footer` })};
	text-align: end;
`;
const FooterLogoTextWrapper = styled.div`
	display: flex;
	flex-direction: column;
	gap: 1rem;
	justify-content: center;
	align-items: flex-start;
	padding-left: 1rem;

	@media (min-width: ${breakpoints.md}) {
		flex-direction: row;
		align-items: flex-end;
		padding-left: 0;
	}
`;
const LogoWrapper = styled.div`
	display: flex;
	justify-content: center;
	align-items: center;
	height: 8rem;
	width: 8rem;
	border-radius: 1rem;
	${background(`elevated.1`)}
`;
const FooterLeftTitle = styled.p`
	${text({ family: `quicksand`, size: 2, colour: `footer` })}
`;
const OurNames = styled.p`
	${text({ family: `quicksand`, size: 2, colour: `footer` })}
`;
const FooterRight = styled.div`
	@media (min-width: ${breakpoints.md}) {
		justify-content: flex-end;
	}
	display: flex;
	justify-content: flex-start;
	padding: 0 4rem 1rem 0;
`;
const CardSmall = styled(CardMobile)`
	@media (min-width: ${breakpoints.md}) {
		display: none;
	}
`;
const CardSmall2 = styled(CardMobile2)`
	@media (min-width: ${breakpoints.md}) {
		display: none;
	}
`;
const CardBig = styled(CardIcon)`
	display: none;
	@media (min-width: ${breakpoints.md}) {
		display: flex;
	}
`;
const CardBig2 = styled(CardIcon2)`
	display: none;
	@media (min-width: ${breakpoints.md}) {
		display: flex;
	}
`;
